/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
/* 
Module version: 3.00
*/
#include <Ble_Application.h>
#include <Application.h>
#include <stdio.h>
#include <string.h>

cy_stc_ble_gap_connected_param_t conn_param;

int8_t rssi;
volatile e_evt_req_t rssi_ers = EVT_REQ_CMPLT;
int8_t txpwrlvl;
volatile e_evt_req_t txpwrlvl_ers = EVT_REQ_CMPLT;


void StackEventHandler(uint32 event, void* eventParam)
{   
    switch(event)
    {
        /* Mandatory events to be handled by Find Me Target design */
        case CY_BLE_EVT_STACK_ON:
        case CY_BLE_EVT_GAP_DEVICE_DISCONNECTED:
            /* Start BLE advertisement for 30 seconds and update link status on LEDs */
            Cy_BLE_GAPP_StartAdvertisement(CY_BLE_ADVERTISING_FAST, CY_BLE_PERIPHERAL_CONFIGURATION_0_INDEX);            
            Cy_GPIO_Write(Advertising_LED_0_PORT, Advertising_LED_0_NUM, LED_ON);
            DeviceConnection=false;
            alertLevel=0;            
        break;
              
        case CY_BLE_EVT_GAP_DEVICE_CONNECTED:                 
            /* BLE link is established */            
			memcpy(&conn_param, eventParam, sizeof( cy_stc_ble_gap_connected_param_t));      // Copy the connection parameters to the static struct.
            
            DeviceConnection=true; 
            Cy_GPIO_Write(Advertising_LED_0_PORT, Advertising_LED_0_NUM, LED_OFF);
        break;

        case CY_BLE_EVT_GAPP_ADVERTISEMENT_START_STOP:
            /* Start BLE advertisement for 30 seconds and update link status on LEDs */            
            if(Cy_BLE_GetAdvertisementState() == CY_BLE_ADV_STATE_STOPPED)
            {
                Cy_GPIO_Write(Advertising_LED_0_PORT, Advertising_LED_0_NUM, LED_OFF);     
            }          
        break;
            
        case CY_BLE_EVT_GET_RSSI_COMPLETE:
		{
Cy_GPIO_Write(EVT_1_PORT, EVT_1_NUM, 1);
            cy_stc_ble_events_param_generic_t * param = (cy_stc_ble_events_param_generic_t*) eventParam;
			rssi = ((cy_stc_ble_rssi_info_t*) param->eventParams)->rssi;
			rssi_ers = EVT_REQ_CMPLT;

Cy_GPIO_Write(EVT_1_PORT, EVT_1_NUM, 0);
        break;
		}
        case CY_BLE_EVT_GET_TX_PWR_COMPLETE:
		{
Cy_GPIO_Write(EVT_2_PORT, EVT_2_NUM, 1);
            cy_stc_ble_events_param_generic_t * param = (cy_stc_ble_events_param_generic_t*) eventParam;
			txpwrlvl = ((cy_stc_ble_tx_pwr_lvl_info_t*) param->eventParams)->blePwrLevel;
			txpwrlvl_ers = EVT_REQ_CMPLT;

Cy_GPIO_Write(EVT_2_PORT, EVT_2_NUM, 0);
        break;
		}
        default:
        break;
    }    
}


/* [] END OF FILE */
